
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; MODULE      : cas.scm
;; DESCRIPTION : General tools for links with cas'
;; COPYRIGHT   : (C) 1999  Joris van der Hoeven
;;
;; This software falls under the GNU general public license and comes WITHOUT
;; ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for details.
;; If you don't have this file, write to the Free Software Foundation, Inc.,
;; 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; tab completion
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define cas-supports-completions (make-hash-table 1000))

(define (cas-supports-completions-set! key)
  (hash-set! cas-supports-completions key #t))

(define (cas-supports-completions? key)
  (hash-ref cas-supports-completions key))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; operations on selections (not finished)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (tree->cas lan t)
  (cas-math-input (list 'tuple lan (tree->object t))))

(define (input->cas lan t)
  (if (and ((equal? (tree-get-label t) 'expand)
	    (= (tree-arity t) 2)
	    (equal? (tree-ref t 0) (tree "math"))))
      (tree->cas lan t)
      (tree->verbatim t)))

(define (maxima-expand)
  (if (selection-active-any?)
      (let* ((t (the-selection))
	     (s (tree->cas "maxima" t))
	     (r (string-append s ";"))
	     (u (connection-eval "maxima" "default" (string->tree r))))
	(cut "primary")
	(insert-tree u))))
