
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; MODULE      : r.scm
;; DESCRIPTION : Support for GNU r
;; COPYRIGHT   : (C) 1999  Michael Lachmann and Joris van der Hoeven
;;
;; This software falls under the GNU general public license and comes WITHOUT
;; ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for details.
;; If you don't have this file, write to the Free Software Foundation, Inc.,
;; 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Specific conversion routines
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (r-input-var-row r)
  (if (not (null? r))
      (begin
	(display ", ")
	(cas-input (car r))
	(r-input-var-row (cdr r)))))

(define (r-input-row r)
  (cas-input (car r))
  (r-input-var-row (cdr r))
 )

(define (r-input-var-rows t)
  (if (not (null? t))
      (begin
	(display ", ")
	(r-input-row (car t))
	(r-input-var-rows (cdr t)))))

(define (r-input-rows t)
  (display "t(matrix(c(")
  (r-input-row (car t))
  (r-input-var-rows (cdr t))
  (display "), ")
  (display (length (car t)))
  (display ", ")
  (display (length t))
  (display " ))")  
)

(define (r-input-det args)
  (display "det(")
    (cas-input-descend-last args)
      (display ")"))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Initialization
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(connection-declare "r" "tm_r")
(connection-format "r" "verbatim" "generic")
(set! session-menu (menu-merge session-menu
  '(("R" (make-session "r" "default")))))
(define (in-r?) (equal? (get-env "prog language") "r"))
;(cas-supports-completions-set! "r")
(display "")

(cas-supports-math-input-set! "r")
(set! cas-input-current-cas "r")
(cas-input-set! 'rows r-input-rows)
(cas-input-set! 'det r-input-det)
(cas-input-set! 'sum r-input-det)

(cas-input-set! "<vee>" " | ")
(cas-input-set! "<wedge>" " & ")
(cas-input-set! "<leftarrow>" " <less>- ")
(cas-input-set! "<infty>" " Inf ")
(cas-input-set! "<varnothing>" "NULL")
(cas-input-set! "<cdots>" ":")
(cas-input-set! "<ldots>" ":")

(display "")
